﻿package proudy2;

import java.text.Collator;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

public class Program 
{
    private static ArrayList<Kontakt> kontakty = new ArrayList<>();
    
    private static void příprava()
    {
        kontakty.add(new Kontakt("Jan Vopršálek", "soukromý", "123456789"));
        kontakty.add(new Kontakt("Jana Vopršálková", "pracovní", "456789123"));
        kontakty.add(new Kontakt("Ivan Mrázek", "soukromý", "987654321"));
        kontakty.add(new Kontakt("Ivan Mrázek", "pracovní", "654654852"));
        kontakty.add(new Kontakt("Karla Horká", "pracovní", "121245458"));
        kontakty.add(new Kontakt("Ája Vomáčková", "soukromý", "123123321"));
    }
    
    public static void výpisVšechKontaktů()
    {
        kontakty.stream().forEach((k)->System.out.println(k));
    }
    
    public static void upravSoukroméKontakty()
    {
        kontakty.stream().filter(k -> k.typ.equals("pracovní"))
            .forEach(k -> k.telefon = "2" + k.telefon);
    }
    
    public static void seřazenáJménaPoprvé()
    {
        kontakty.stream().map((kont)->kont.jméno)
                .distinct()
                .sorted()
                .forEach(s->System.out.println(s));
    }
    
    public static void seřazenáJménaObráceně()
    {
        kontakty.stream().map((kont)->kont.jméno)
                .distinct()
                .sorted(Collator.getInstance().reversed())
                .forEach(s->System.out.println(s));
    }
    
    public static void seřazenáJménaPodruhé()
    {
        kontakty.stream().map((kont)->kont.jméno)
                .distinct()
                .sorted(Collator.getInstance())
                .forEach(s->System.out.println(s));
    }
    
    public static String[] kontaktyJakoPole()
    {
        return kontakty.stream().map((kon)->kon.jméno + ", ").distinct().toArray(String[]::new);
    }
                
    public static String kontaktyJakoŘetězec()
    {
        return kontakty.stream()
            .map((kon)->kon.jméno + ", ").distinct()
            .collect(StringBuilder::new, StringBuilder::append, StringBuilder::append)
            .toString();
    }
    
    public static List<String> datovodNaKolekci()
    {
       return kontakty.stream().map((kon)->kon.jméno + ", ").distinct().collect(Collectors.toList());
    }
    
    public static void main(String[] args) 
    {
        příprava();
        // Úvodní příklady
        výpisVšechKontaktů();
        upravSoukroméKontakty();
        System.out.println("---");
        výpisVšechKontaktů();
        // Řazení
        seřazenáJménaPoprvé();
        System.out.println("---");
        seřazenáJménaPodruhé();
        System.out.println("---");
        seřazenáJménaObráceně();

        // Převod proudu na pole
        for(var prvek: kontaktyJakoPole())
        {
            System.out.println(prvek);
        }
        
        // Převod na řetězec a na kolekci
        System.out.println(kontaktyJakoŘetězec());
        var seznam = datovodNaKolekci();
        for(var s: seznam)
            System.out.println(s);
        // Rozdělení kontaktů podle typu
        Map<String, List<Kontakt>> kontaktyPodleTypu = kontakty.stream().collect(Collectors.groupingBy(kon->kon.typ));
        List<Kontakt> soukromé = kontaktyPodleTypu.get("soukromý");
        for(var k: soukromé)
            System.out.println(k);
    }
}
