package soubory;

import java.io.File;
import java.io.IOException;
import java.util.Arrays;
import java.util.function.Predicate;

public class Program 
{   
    public static File vytvoNovPrzdnSoubor(String jmno)
                    throws java.io.IOException
    {
        File soubor = new File(jmno);          // Instance soubor
        if(soubor.exists()) soubor.delete();    // Pokud existuje, sma ho
        soubor.createNewFile();                 // Vytvo nov soubor
        return soubor;                          // Vra odkaz na soubor
    }
    
    private static void vypi(String nadpis, File[] obsahAdrese, Predicate<File> f)
    {
        System.out.println(nadpis + ": ");
        for(var poloka: obsahAdrese)
        {
            if(f.test(poloka))
                System.out.println(poloka.getAbsoluteFile());
        }
        
    }
    
    public static void vypiAdres(String jmno)
            
    {
        File adres = new File(jmno);
        if(adres.isDirectory())
        {
            File[] obsahAdrese = adres.listFiles();
            vypi("Adrese", obsahAdrese, File::isDirectory);
            vypi("Soubory", obsahAdrese, File::isFile);
        }
        else 
        {
            System.out.println("Zadan cesta " + jmno + " nepedstavuje adres");
        }
    }


    public static void main(String[] args) throws IOException 
    {
        vytvoNovPrzdnSoubor("data.dta");
        vypiAdres(".");
    }
    
}
