package jfxveswingu;

import java.awt.BorderLayout;
import javafx.application.Platform;
import javafx.embed.swing.JFXPanel;
import javafx.scene.Scene;
import javafx.scene.layout.BorderPane;
import javafx.scene.paint.Color;
import javafx.scene.text.*;
import javax.swing.*;


public class Program 
{
    private static void vytvořOkno() 
    {
        // Volána pod EDT
        okno = new JFrame("Swing a JavaFX");
        okno.setLayout(new BorderLayout());
        fxPanel = new JFXPanel();
        okno.add(fxPanel, BorderLayout.CENTER);
        
        okno.setSize(300, 200);
        okno.setVisible(true);
        okno.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        
        tlačítko = new JButton("Stiskni");
        okno.add(tlačítko, BorderLayout.NORTH);
        tlačítko.addActionListener(e->Platform.runLater(()->text.setText("Povedlo se...")));

        Platform.runLater(() -> inicializujFX(fxPanel));
    }

    private static void inicializujFX(JFXPanel fxPanel) 
    {
        // Volána pod JFXAT
        Scene scéna = vytvořScénu();
        fxPanel.setScene(scéna);
    }
    

    private static Scene vytvořScénu() 
    {
        BorderPane obsah  =  new  BorderPane();
        Scene scéna  =  new  Scene(obsah, Color.ALICEBLUE);
        text  =  new  Text();
        text.setFont(new Font(25));
        text.setText("JavaFX zdraví Swing.");
        obsah.setCenter(text);
        return scéna;
    }
    
    public static void main(String[] args) 
    {
        SwingUtilities.invokeLater(() -> vytvořOkno());
    }
    
    private static Text text;
    
    // Komponenty z knihovny Swing
    private static JFrame okno;
    private static JButton tlačítko;
    
    // Spojovací komponenta
    private static JFXPanel fxPanel;
}
